#
#	HBS REDUCTION SUB ROUTINE
#
#	File conversion for CL : andorhconv.cl
#
#       2005/09/09      M.Isogai      Ver.1.00   based on hbsfconv.cl

procedure andorhconv

begin
  
  int c, j
  file fn, fnnext
  file tmp_fn
  int flag_erase = 0
  string fn_stack[5000]
  int n_image
  string buf, buf1, buf2

  int flag_inquiry   # 1: 'flag_overwrite' applies to all image
  int flag_overwrite # 0:skip 1:overwrite
  int flag_ver       # 0:no display 1:display
  int n_version      # IRAF version (210 or 211)

  file logfn

#--- initial settings

  logfn = envget( "_logfile" )

  if( access( "hbs.tmp.time" ) == 1 )
    delete( "hbs.tmp.time", ver- )
  time >> hbs.tmp.time
  list = "hbs.tmp.time"
  if( fscan( list, buf, buf1, buf2 ) != 3 )
  {
    printf( "Error: time task -- reading\n" )
    bye
  }
  delete( "hbs.tmp.time", ver- )

  printf( "\n" )
  printf( "%s %s\n", buf1, buf2 )
  printf( "-----------------\n" )
  printf( " File Conversion\n" )
  printf( "-----------------\n" )
  printf( "\n" )

  printf( "\n", >> logfn )
  printf( "%s %s\n", buf1, buf2, >> logfn )
  printf( "-----------------\n", >> logfn )
  printf( " File Conversion\n", >> logfn )
  printf( "-----------------\n", >> logfn )
  printf( "\n", >> logfn )

  tmp_fn = mktemp( "hbs.tmp.fn." )


#--- Verbose Mode

  if( envget( "_fg_ver" ) == "1" )
  {
    flag_ver = 1
  }
  else
  {
    if( envget( "_fg_ver" ) == "2" )
    {
      flag_ver = 0
    }
    else
    {
      printf( "'hbsinit' process is incomplete.(_fg_ver) Retry.\n" )
      printf( "'hbsinit' process is incomplete.(_fg_ver) Retry.\n",\
              >> logfn )
      bye
    }
  }

#----- Replace Mode

  if( envget( "_fg_mode" ) == "1" )
  {
    flag_inquiry = 1
    flag_overwrite = 1
  }
  else
  {
    if( envget( "_fg_mode" ) == "2" )
    {
      flag_inquiry = 1
      flag_overwrite = 0
    }
    else
    {
      if( envget( "_fg_mode" ) == "3" )
      {
        flag_inquiry = 0
        flag_overwrite = 0
      }
      else
      {
        printf( "'hbsinit' process is incomplete.(_fg_mode) Retry.\n" )
        printf( "'hbsinit' process is incomplete.(_fg_mode) Retry.\n",\
	  >> logfn )
        bye
      }
    }
  }
    
#----- Erase/Reserve old image

  if( envget( "_fg_del1" ) == "1" )
  {
    flag_erase = 1
  }
  else
  {
    if( envget( "_fg_del1" ) == "2" )
    {
      flag_erase = 0
    }
    else
    {
      printf( "'hbsinit' process is incomplete.(_fg_del1) Retry.\n" )
      printf( "'hbsinit' process is incomplete.(_fg_del1) Retry.\n",\
      >> logfn )
      bye
    }
  }

#----- IRAF version check

  buf1 = envget( "version" )
  c = stridx( "V", buf1 )
  buf2 = substr( buf1, c, ( c + 4 ) )

  n_version = 0

  if( buf2 == "V2.11" || buf2 == "V2.12" )
  {
    n_version = 211
  }
  else
  {
    if( buf2 == "V2.10" )
    {
      n_version = 210
    }
  }

  if( n_version == 0 )
  {
    printf( "IRAF version check failed.\n" )
    printf( "Please input like next line, and restart 'hbsred'\n" )
    printf( "cl> set version V2.10  (V2.10 and V2.11 are valid)\n" )
    printf( "IRAF version check failed.\n", >> logfn )
    printf( "Please input like next line, and restart 'hbsred'\n", >> logfn )
    printf( "cl> set version V2.10  (V2.10 and V2.11 are valid)\n", >> logfn )
    bye
  }

#----- Andor fts file --> Andor fit file (only edit header)


  printf( "Cryofits4 proceeding... ", >> logfn )
  cryofits4
  printf( "done.\n", >> logfn )

  if( flag_erase == 1 )
  {
    printf( "Now scanning and deleting old files\n" )
    printf( "Now scanning and deleting old files\n", >> logfn )
    sections( "*.fts", option="fullname", > tmp_fn )
    list = tmp_fn
    while( fscan( list, buf1 ) != EOF )
    {
      c = strlen( buf1 )
      buf2 = substr( buf1, 1, ( c - 3 ) )//"fit"
      if( access( buf2 ) == 1 )
        delete( buf1, ver- )
    }
    delete( tmp_fn, ver- )
  }


end
