#
#       HBS REDUCTION SUB ROUTINE
#
#       make table of obs-time ond count for each position of hwp
#                             : hbscounttime.cl
#
#
procedure hbsskyunpol( inlist, outframe )

file inlist	{ prompt = "Image list" }
file outframe	{ prompt = "head name of output table" }

begin

  string fn[300]
  int n_image
  real jd, jd_tmp
  real fz
  real c[4]
  int x1, x2
  int y1[4]
  int y2[4]
  string hbslist
  string beta1, beta2
  file tmp_fn
  int nposhwp
  real poshwp
  string outhead, outfile[5]
  string buf
  int i, j

  x1 = 200
  x2 = 220
  y1[1] = 33
  y2[1] = 43
  y1[2] = 74
  y2[2] = 84
  y1[3] = 119
  y2[3] = 129
  y1[4] = 158
  y2[4] = 168

#----- scan list files and make averaged image

  tmp_fn = mktemp( "hbs.tmp.fn." )

  hbslist = inlist
  outhead = outframe

  for( i=1; i<=4; i+=1 )
  {
    outfile[i] = outhead//(i-1)//".xy"
    if( access( outfile[i] ) == 1 )
      delete( outfile[i], ver- )
  }

  print( "Now scanning "//hbslist )
  n_image = 0
  list = hbslist
  while( fscan( list, buf ) != EOF )
  {
    n_image += 1
    fn[n_image] = buf
  }

  for( i=1; i<=n_image; i+=1 )
  {
    imgets( fn[i], "JD" )
    jd_tmp = real( imgets.value )
    imgets( fn[i], "AIRMASS" )
    fz = real( imgets.value )
    imgets( fn[i], "POS-HWP" )
    poshwp = real( imgets.value )
    nposhwp = int( poshwp / 22.499999 )
    jd = jd_tmp - 2450000

    for( j=1; j<=4; j+=1 )
    {
      imstat( fn[i]//"["//x1//":"//x2//","//y1[j]//":"//y2[j]//"]",\
              field="mean", format-, >> tmp_fn )
      list = tmp_fn
      if( fscan( list, buf ) != 1 )
      {
        printf( "error in reading imstat file\n" )
        bye
      }
      c[j] = real( buf )
      delete( tmp_fn, ver- )
    }

    printf( "%15s %4.1f %10.5f %6.4f %8.2f %8.2f %8.2f %8.2f\n", fn[i],\
            poshwp, jd, fz, c[1], c[2], c[3], c[4] )

    buf = outfile[nposhwp+1]

    printf( "%15s %4.1f %10.5f %6.4f %8.2f %8.2f %8.2f %8.2f\n", fn[i],\
            poshwp, jd, fz, c[1], c[2], c[3], c[4], >> buf )

  }

end
