#
#       HBS REDUCTION SUB ROUTINE
#
#       make ratio (extraordinary to ordinary) image : hbseoo.cl
#
#       1997/05/01      K.Kawabata  Ver.0.10  for CRYOCAM manual reduc
#

procedure hbseoo


begin

  file listoflist = "HBS.list"
  string hbslist[50]
  string shorttyp[50], title[50]
  string exptime[50], diaph[50], filter[50]
  string slit[50]
  int c, i, j, n, n_list

  file fn
  string fnobe1, fnobo1, fn2
  file tmp_list
  string buf, buf1, buf2, buf3, buf4, buf5, buf6, buf7

  print( "" )
  print( "------------------------------" )
  print( " make ratio (ext/ord) spectra"
  print( "------------------------------" )
  print( "" )

  tmp_list = mktemp( "hbs.tmp.list." )

#----- Scanning the list file

  if( access( listoflist ) == 0 )
  {
    print( "Cannot find "//listoflist//"   Please do hbsgroup" )
    bye
  }

  n_list = 0
  list = listoflist
  while( fscan(list, buf1, buf2, buf3, buf4, buf5, buf6, buf7) != EOF )
  {
    if( substr( buf1, 1, 3 ) != "HBS" )
    {
      print( "The list-file ", listoflist, " is not produced by HBSGROUP.CL" )
      break
    }
    if( buf2 != "OBJ" && buf2 != "COM" )
      next
    n_list += 1
    hbslist[n_list] = buf1
    shorttyp[n_list] = buf2
    title[n_list] = buf3
    exptime[n_list] = buf4
    diaph[n_list] = buf5
    filter[n_list] = buf6
    slit[n_list] = buf7
  }

#----- main routine

  for( i=1; i<=n_list; i+=1 )
  {
    if( shorttyp[i] != "DAR" && shorttyp[i] != "BIA" &&\
        shorttyp[i] != "NEA" )
    {
      if( substr( diaph[i]//"____", 1, 7 ) == "2SLIT01" )
      {
        print( "%%%%% Avoided %%%%% "//hbslist[i]//"(using 2SLIT01 diaph.)" )
        next
      }
      printf( "--- OBJECT LIST : %s ---\n", hbslist[i] )
      sed( 's/fit\.imh//', hbslist[i], > tmp_list )

      list = tmp_list
      while( fscan( list, fn ) != EOF )
      {
        printf( "%s  ", fn )

#----- make ratio spectrum

        fnobe1 = fn//"co.e"
        fnobo1 = fn//"co.o"
        fn2 = fn//"co.eoo"

        imarith( fnobe1, "/", fnobo1, fn2, pixtype="real",\
                 calctype="real", ver- )
      }
      printf( "\n" )
      delete( tmp_list, ver- )
    }
  }

end
