#
#	HBS REDUCTION SUB ROUTINE
#
#	Grouping images: hbsgroup.cl
#
#	1995/10/05	K.Kawabata
#       1995/11/22      K.Kawabata    Ver.1.10
#       1997/11/04      K.Kawabata    Ver.1.20  combined code
#       1998/04/20      K.Kawabata    Ver.2.00  unification
#       1998/05/31      K.Kawabata    Ver.2.10
#       1998/05/31      K.Kawabata    Ver.2.20  separate different night
#       2000/02/29      K.Kawabata    Ver.3.00  for SITe CCD
#

procedure hbsgroup

begin

  string grouplist[500], grouplistsub[500]
  real groupjd[500]
  int ngrlim = 500
  string inlist = "hbs.tmp.list.fit"
  string listoflist
  string calmode = "" # 1:object, 2:UP,SP,GT
  file fn, fn_record
  file tmp_list
  string outfile, outfilesub
  string datatyp, title
  string exptime, filter, diaph
  string slit, shorttyp
  real obsjd
  int nposhwp
  int maxnposhwp = 0
  file fn_nposhwp
  int flag_obj = 0 # 0:no OBJ group  1: OBJ group exist
  int c
  string buf = ""
  string buf1, buf2
  int n_group, n_tmp, i
  file logfn

#--- initial settings
  tmp_list = mktemp( "hbs.tmp.fn." )
  listoflist = envget( "_rootlist" )
  fn_nposhwp = envget( "_nposhwp" )
  logfn = envget( "_logfile" )

  calmode = envget ( "_objcal" )
  if( calmode == "" ) # for old version of hbsinit.cl
    calmode = "1"

  if( access( "hbs.tmp.time" ) == 1 )
    delete( "hbs.tmp.time", ver- )
  time >> hbs.tmp.time
  list = "hbs.tmp.time"
  if( fscan( list, buf, buf1, buf2 ) != 3 )
  {
    printf( "Error: time task -- reading\n" )
    bye
  }
  delete( "hbs.tmp.time", ver- )

  printf( "\n" )
  printf( "%s %s\n", buf1, buf2 )
  printf( "-----------------\n" )
  printf( " Grouping Images\n" )
  printf( "-----------------\n" )
  printf( "\n" )

  printf( "\n", >> logfn )
  printf( "%s %s\n", buf1, buf2, >> logfn )
  printf( "-----------------\n", >> logfn )
  printf( " Grouping Images\n", >> logfn )
  printf( "-----------------\n", >> logfn )
  printf( "\n", >> logfn )

#--- DELETE OLD FILES

  if( access( listoflist ) == 1 )
    delete( listoflist, ver- )

  sections( "HBS.???.*", option="fullname", > tmp_list )

  if( sections.nimages > 0 )
    delete( "@"//tmp_list )

  delete( tmp_list, ver- ) 
 
  if( access( fn_nposhwp ) == 1 )
    delete( fn_nposhwp, ver- )

#--- INITIALIZE VARIABLES

  n_group = 0
  for( i=1; i<=100; i+=1 )
  {
    grouplist[i] = ""
    grouplistsub[i] = ""
    groupjd[i] = 0.0
  }

#--- MAKE '*.fit.imh' list

  if( access( inlist ) == 1 )
    delete( inlist, ver- )
  sections( "*.fit.imh", option="fullname", > inlist )
#  sections( "*.px.1.imh", option="fullname", > tmp_list )
#  sed( 's/px.1.imh//', tmp_list, > inlist )
#  delete( tmp_list, ver- )

#--- GROUPING IMAGES

  list = inlist

  print( "now grouping images..." )
  while( fscan( list, buf ) != EOF )
  {
    fn = buf
    fn_record = buf
#    fn_record = buf//"fit.imh"
#    fn = buf//"px.1.imh"
    imgets( fn, 'DATA-TYP' )
    datatyp = imgets.value
    shorttyp = substr( datatyp, 1, 3 )
    if( shorttyp == "OBJ" )
      flag_obj = 1

    imgets( fn, 'HBSTITLE' )
    title = imgets.value

    imgets( fn, 'EXPTIME' )
    exptime = str( int( imgets.value ) )

    imgets( fn, 'DIAPHRAG' )
    buf = imgets.value
    buf1 = "UND"
    buf2 = "M"
    k = strlen( buf )
    if( substr( buf//"____", 1, 5 ) == "1HOLE" )
      buf1 = "1HL"
    if( substr( buf//"____", 1, 6 ) == "2HOLES" )
      buf1 = "2HL"
    if( substr( buf//"____", 1, 7 ) == "2SLIT01" )
      buf1 = "2S1"
    if( substr( buf//"____", 1, 7 ) == "2SLIT02" )
      buf1 = "2S2"
    if( substr( buf//"____", 1, 8 ) == "1SLIT004" )
      buf1 = "1S4"
    if( substr( buf, (k-4), k ) == "LOWER" )
      buf2 = "L"
    if( substr( buf, (k-4), k ) == "UPPER" )
      buf2 = "U"
    diaph = buf1//buf2

    imgets( fn, 'FILTER' )
    buf = imgets.value
    k = strlen( buf )
    if( k > 5 )
    {
      if( buf == "NO_FILTER" )
        filter = "NO"
      else
        filter = substr( buf, 1, 3 )//substr( buf, (k-1), k )
    }
    else
    {
      filter = buf
    }
    imgets( fn, 'SLIT-WID' )
    slit = imgets.value
    imgets( fn, 'POS-HWP' )
    nposhwp = int( real( imgets.value ) / 22.499999 )
    maxnposhwp = max( maxnposhwp, nposhwp )

    imgets( fn, 'JD' )
    obsjd = real( imgets.value ) - 2400000.0


    outfile = "HBS."//shorttyp//"."//title//"."

    outfilesub = "HBS."//shorttyp//"."//title//"."//exptime//"_"//\
                 diaph//"_"//filter//"_"//slit

    if( n_group == 0 )
    {
      n_group = 1
      goto p1
    }
    for( i=1; i<=n_group; i+=1 )
    {
      if( calmode == "1" )
      {
        if( outfilesub == grouplistsub[i] )
        {
	  outfile = grouplist[i]
          groupjd[i] = obsjd
          goto p2
	}
      }
      else
      {
        if( outfilesub == grouplistsub[i] && abs( obsjd - groupjd[i] ) < 0.2 )
        {
	  outfile = grouplist[i]
          groupjd[i] = obsjd
          goto p2
	}
      }
    }
    n_group += 1
    if( n_group > ngrlim )
    {
      print( "Number of searched group exceeds %d", ngrlim )
      print( "!*!*! grouping is finished insted of incompletion !*!*!" )
      print( "Number of searched group exceeds %d", ngrlim, >> logfn )
      print( "!*!*! grouping is finished insted of incompletion !*!*!",\
       >> logfn )
      goto p3
    }

p1 :
    n_tmp = 1
    for( i=1; i<=(n_group-1); i+=1 )
    {
      if( outfile == substr( grouplist[i], 1, strlen( outfile ) ) )
        n_tmp += 1
    }
    grouplistsub[n_group] = outfilesub
    grouplist[n_group] = outfile//n_tmp
    groupjd[n_group] = obsjd
    outfile = grouplist[n_group]

    print( outfile//"   "//shorttyp//" "//title//" "//exptime//" "\
           //diaph//" "//filter//" "//slit, >> listoflist )

p2 :

    print( fn_record, >> outfile )

    printf( "%s  %s  %s\n", fn_record, outfilesub, outfile )
    printf( "%s  %s  %s\n", fn_record, outfilesub, outfile, >> logfn )

  }

p3 :

#--- PRINT and CONFIRMATION

  if( access( inlist ) == 1 )
    delete( inlist, ver- )

  printf( "%2d\n", ( maxnposhwp + 1 ), > fn_nposhwp )

  for( i=1; i<=n_group; i+=1)
  {
    printf( "-- %s  (%s) --\n", grouplist[i], grouplistsub[i] )
    type( grouplist[i] )
    printf( "-- %s  (%s) --\n", grouplist[i], grouplistsub[i], >> logfn )
    type( grouplist[i], >> logfn )
  }

  print("Number of detected group = ", n_group)
  print("Number of detected group = ", n_group, >> logfn)


#--- set parameters

  if( flag_obj == 1 )
    hbsparam

end
