#
#       HBS REDUCTION SUB ROUTINE
#
#       average images with average-sigma-clipping for its binned value
#
#       1998/05/31      K.Kawabata ver.2.10  unification
#
#

procedure hbsmyphot( inhead, inbintab )

string inhead { prompt = "Head name of set (need ??i2.ave ??c2i1.ave ??c2i1.sig)" }
string inbintab { prompt = "Head name of bintab (e.g. HBS.OBJ.CHCyg.1.bintab)" }

begin

  real x[10]
  real cx
  string fnhead, fnbintab
  string fnobji2a, fnc2i1a, fnc2i1s, fnobjerr

  fnhead = inhead
  fnbintab = inbintab

  fnobji2a = inhead//"i2.ave"
  fnc2i1a = inhead//"c2i1.ave"
  fnc2i1s = inhead//"c2i1.sig"
  fnobjerr = inhead//"i1.err"

  if( access( fnobji2a//".imh" ) == 0 )
  {
    printf( "'%s' not found.\n", fnobji2a )
    return
  } 
  if( access( fnc2i1a//".imh" ) == 0 )
  {
    printf( "'%s' not found.\n", fnc2i1a )
    return
  } 
  if( access( fnc2i1s//".imh" ) == 0 )
  {
    printf( "'%s' not found.\n", fnc2i1s )
    return
  } 
  if( access( fnobjerr//".imh" ) == 1 )
  {
    imdelete( hbsobjerr, ver- )
  } 

#  hbsphsig( "chcygi2.ave", "HBS.OBJ.CH_Cyg.1.bintab", "chcygc2i1.ave",\
#            "chcygc2i1.sig", "chcygi1.err" )
  hbsphsig( fnobji2a, fnbintab, fnc2i1a, fnc2i1s, fnobjerr )

#  hbsphbin( "chcyg.cor", "chcyg0.xy", "chcygi1.err",\
#            "HBS.OBJ.CH_Cyg.1.bintab", "chcygi1.bin", "chcyg2.xy" )
  hbsphbin( "chcyg.cor", "chcyg0.xy", "chcygi1.err",\
            "HBS.OBJ.CH_Cyg.1.bintab", "chcygi1.bin", "chcyg2.xy" )

  printf( "'chcyg2.xy' produced.\n" )

end
